import {
  csv,
  select,
  scaleLinear,
} from 'd3';
//
import { scatterPlot } from './scatterPlot';
const csvUrl = [
  'https://gist.githubusercontent.com/',
  'curran/',
  'a08a1080b88344b0c8a7/',
  'raw/0e7a9b0a5d22642a06d3d5b9bcbad9890c8ee534/',
  'iris.csv',
].join('');
// console.log(d3);
//csv(csvUrl) is a request operation
//columns ['sepal.length', 'sepal.width', 'petal.length', 'petal.width', 'variety']
const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;
  console.log(typeof d.sepal_length);

  return d;
};

//       const xValue = (d) => {
//         d.sepal_length = +d.sepal_length;
//         d.sepal_width = +d.sepal_width;
//         d.petal_length = +d.petal_length;

//         d.petal_width = +d.petal_width;

//         return d.petal_length;
//       };
//       const yValue = (d) => {
//         d.sepal_length = +d.sepal_length;
//         d.sepal_width = +d.sepal_width;
//         d.petal_length = +d.petal_length;
//         d.petal_width = +d.petal_width;
//         return d.sepal_length;
//       };

const width = window.innerWidth;
const height = window.innerHeight;

const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const main = async () => {
  const data = await csv(csvUrl, parseRow);
  svg.call(
    scatterPlot()
      .width(width)
      .height(height)
      .data(data)
      .xValue((d) => d.petal_length)
      .yValue((d) => d.sepal_length)
      .margin({
        top: 20,
        right: 20,
        left: 50,
        bottom: 40,
      })
      .radius(5)
  );

  //   console.log(data);
  //   // scaleLinear does a mapping from data to screen

  //   //         const x = scaleLinear().domain([
  //   //           d3.min(data, xValue),
  //   //           d3.max(data, xValue),]
  //   //           // d3.min(+data.petal_length),
  //   //           // d3.max(+data.sepal_length),

  //   //         );
  //   const x = scaleLinear()
  //     .domain(extent(data, xValue))
  //     //.range([0, width]);
  //     .range([margin.left, width - margin.right]);
  //   const y = scaleLinear()
  //     .domain(extent(data, yValue))
  //     //.range([height, 0]);
  //     .range([height - margin.bottom, margin.top]);

  //   //console.log(x.range());

  //   const marks = data.map((d) => ({
  //     x: x(xValue(d)),
  //     y: y(yValue(d)),
  //     p_x: xValue(d),
  //     p_y: yValue(d),
  //   }));
  //   console.log(marks);
  //   svg
  //     .selectAll('circle')
  //     .data(marks)
  //     .join('circle')
  //     .attr('cx', (d) => d.x)
  //     .attr('cy', (d) => d.y)
  //     .attr('r', 5)
  //     .append('title')
  //     .text((d) => `(${d.p_x},${d.p_y})`);
  //   svg
  //     .append('g')
  //     .attr(
  //       'transform',
  //       `translate(${margin.left},0)`
  //     )
  //     .call(axisLeft(y));
  //   svg
  //     .append('g')
  //     .attr(
  //       'transform',
  //       `translate(0, ${height - margin.bottom})`
  //     )
  //     .call(axisBottom(x));
};
// csv(csvUrl, parseRow).then((data) => {
//   console.log(data);
// });
main();
